'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.resetMocks = exports.resetMock = exports.getAllMocks = exports.getMock = exports.modifyMock = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _path = require('path');

var _common = require('./_common');

var mocks = {};

var modifyMock = function modifyMock(name, stubs) {
    var stubType = typeof stubs === 'undefined' ? 'undefined' : _typeof(stubs);
    var oldMock = mocks[name];
    if (stubType === 'object') {
        mocks[name] = _extends({}, mocks[name], stubs);
    } else {
        mocks[name] = stubs;
    }

    _common.magicProps.forEach(function (key) {
        if (oldMock.hasOwnProperty(key)) {
            mocks[name][key] = oldMock[key];
        }
    });
};

var genMock = function genMock(name) {
    var mock = {};
    Object.defineProperty(mock, "__MI_name", {
        value: name
    });
    return mock;
};

var resetMock = function resetMock(name) {
    return mocks[name] = genMock(name);
};

var resetMocks = function resetMocks() {
    return mocks = {};
};

var getMock = function getMock(name) {
    var fn = (0, _path.parse)(name);
    var shortName = (0, _path.join)(fn.dir, fn.name);
    return mocks[name] || mocks[shortName];
};

var getAllMocks = function getAllMocks() {
    return mocks;
};

exports.modifyMock = modifyMock;
exports.getMock = getMock;
exports.getAllMocks = getAllMocks;
exports.resetMock = resetMock;
exports.resetMocks = resetMocks;